;===============================================================================
; Nettool - (C) 2002 by Thomas Bleeker [exagone]. http://www.madwizard.org
;===============================================================================
;
; http://www.madwizard.org
;
.486
.model flat,stdcall
option	casemap:none

;-----------------------------------------------------------------------------
; Libraries & Include files
;-----------------------------------------------------------------------------

includelib 	\masm32\lib\kernel32.lib
includelib 	\masm32\lib\user32.lib
includelib 	\masm32\lib\gdi32.lib
includelib 	\masm32\lib\comctl32.lib
includelib 	\masm32\lib\ws2_32.lib
includelib 	\masm32\lib\masm32.lib

include 	\masm32\include\windows.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\ws2_32.inc
include 	\masm32\include\comctl32.inc
include 	\masm32\include\masm32.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\gdi32.inc

includelib	iphlpapi.lib
include		iphlpapi.inc

include		prog.inc
include		resource.inc
;-----------------------------------------------------------------------------
; Prototypes
;-----------------------------------------------------------------------------
WinMain 				PROTO 	STDCALL :DWORD, :DWORD, :DWORD, :DWORD
WndProc 				PROTO 	STDCALL :DWORD, :DWORD, :DWORD, :DWORD
InitializeListView		PROTO 	STDCALL :DWORD
UpdateListView  		PROTO 	STDCALL
KillConnection 			PROTO 	STDCALL


	
	
;-----------------------------------------------------------------------------
; Initialized data
;-----------------------------------------------------------------------------
.data
AppName			db	"NetTool",0
ClassName		db	"NetTool32",0
classListView	db	"SysListView32",0

textLocalIP		db	"local IP",0
textLocalPort	db	"local port",0
textRemoteIP	db	"remote IP",0
textRemotePort	db	"remote port",0
textStatus		db	"status",0


textStateClosed		db	"closed",0
textStateListen		db	"listening",0
textStateSynSent	db	"syn sent",0
textStateSynRcvd	db	"syn received",0
textStateEstab		db	"established",0
textStateFinWait1	db	"fin wait 1",0
textStateFinWait2	db	"fin wait 2",0
textStateCloseWait	db	"close wait",0
textStateClosing	db	"closing",0
textStateLastAck	db	"last ack",0
textStateTimeWait	db	"time wait",0
textStateDeleteTCB	db	"delete TCB",0
textStateUnkown		db	"? unknown",0

stateTable	dd offset textStateClosed
			dd offset textStateListen		
			dd offset textStateSynSent	
			dd offset textStateSynRcvd	
			dd offset textStateEstab		
			dd offset textStateFinWait1	
			dd offset textStateFinWait2	
			dd offset textStateCloseWait
			dd offset textStateClosing	
			dd offset textStateLastAck	
			dd offset textStateTimeWait	
			dd offset textStateDeleteTCB
			dd offset textStateUnkown
;-----------------------------------------------------------------------------
; Uninitialized data
;-----------------------------------------------------------------------------
.data?

hInstance			  dd ?
hMainListView         dd ?

	
;-----------------------------------------------------------------------------
; Code
;-----------------------------------------------------------------------------
.code
start:

	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	invoke	InitCommonControls
	
	invoke  WinMain, hInstance, NULL, NULL, SW_SHOWNORMAL
	
    invoke	ExitProcess, NULL
    
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
    LOCAL wc:WNDCLASSEX
    LOCAL hwnd:DWORD
    LOCAL msg:MSG
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style,   CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInst
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    invoke  LoadIcon,hInst,IDI_ICON1
    mov     wc.hIcon,   eax
    invoke  LoadIcon,NULL,IDI_APPLICATION		
    mov     wc.hIconSm, eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,    addr wc
    
 
    INVOKE CreateWindowEx,NULL, ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW OR WS_CLIPSIBLINGS OR WS_CLIPCHILDREN,\
            CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
    mov   hwnd,eax
    invoke ShowWindow, hwnd,SW_SHOWNORMAL
    invoke UpdateWindow, hwnd
    .WHILE TRUE
        invoke GetMessage, ADDR msg,NULL,0,0
        .IF		msg.message==WM_KEYUP && msg.wParam==VK_DELETE
        	; Delete key pressed? kill connection:
        	invoke	KillConnection
        	.CONTINUE
        .ENDIF
        	
        .BREAK .IF (!eax)
                invoke TranslateMessage, ADDR msg
                invoke DispatchMessage, ADDR msg
    .ENDW
    mov     eax,msg.wParam
    ret
WinMain endp


.code
WndProc proc uses ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL tmpRct:RECT
	mov eax, uMsg
	.IF eax==WM_CREATE
		invoke	CreateWindowEx, 0, addr classListView, 0, \
					WS_CHILD OR WS_VISIBLE OR \
					LVS_REPORT OR LVS_SINGLESEL,\
					0, 0, 100, 100, \
					hWnd, ID_MAINLISTVIEW, hInstance, 0
		mov		hMainListView, eax
		invoke	InitializeListView, hWnd
		invoke	UpdateListView
		
	.ELSEIF eax==WM_SIZE
		invoke	GetClientRect, hWnd, addr tmpRct
		mov		ecx, tmpRct.right
		mov		edx, tmpRct.bottom
		sub		ecx, tmpRct.left
		sub		edx, tmpRct.top
		invoke	MoveWindow, hMainListView, tmpRct.left, tmpRct.top,\
					ecx, edx, 1
	.ELSEIF eax==WM_ERASEBKGND
		xor		eax, eax
		inc		eax
	.ELSEIF eax==WM_DESTROY
		
		; Post quit message:
		invoke 	PostQuitMessage, NULL
	.ELSE
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
	.ENDIF
ret 
WndProc endp

InitializeListView	proc uses ebx hWnd:DWORD
LOCAL tempColumn:LV_COLUMN
	mov		tempColumn.imask, LVCF_TEXT	OR LVCF_SUBITEM OR LVCF_WIDTH
	mov		tempColumn.lx, 100
	and		tempColumn.iSubItem,0

	;-----------------------
	; Push all strings for the columns on stack,
	; add & pop each one in a loop until the pushed NULL
	; is found

	push	0
	push	offset textStatus
	push	offset textRemotePort
	push	offset textRemoteIP
	push	offset textLocalPort
	push	offset textLocalIP
	xor		ebx, ebx
	.WHILE	1
		pop		eax
		.BREAK .IF eax==0	
		mov		tempColumn.pszText, eax
		invoke	SendMessage, hMainListView, LVM_INSERTCOLUMN, ebx, addr tempColumn  
		inc		tempColumn.iSubItem
		inc		ebx
	.ENDW
ret
InitializeListView  endp





UpdateListView proc uses edi ebx esi
LOCAL	fakeBuffer:DWORD
LOCAL	lnBuffer:DWORD
LOCAL	tempBuffer[128]:BYTE
LOCAL	tempItem:LV_ITEM
	; Lock window to prevent flicker while updating
	invoke	LockWindowUpdate, hMainListView
	
	; Get TCP table in fake buffer of 1 byte. This will cause a 
	; buffer overflow error, the lnBuffer var will be filled with
	; the required amount of memory.
	
	mov		lnBuffer, 1
	invoke 	GetTcpTable, addr fakeBuffer, addr lnBuffer, 1
	invoke	SendMessage, hMainListView, LVM_DELETEALLITEMS,\
					0, addr tempItem
	
	; Allocate the amount of memory neeeded
	invoke	GlobalAlloc, GMEM_FIXED, lnBuffer
	mov		edi, eax
	
	; Get TCP table again, but with a real buffer now
	lea		ecx, lnBuffer
	invoke	GetTcpTable, eax, ecx, 1
	
	mov		ebx, [edi]	; first dword is number of items in tcp table
	
	mov		tempItem.imask, LVIF_TEXT

	; --- loop through all items (ebx), esi is counter ---
	push	edi
	add		edi, 4
	xor		esi, esi
	.WHILE	esi<ebx
		mov		tempItem.iItem, esi
		and		tempItem.iSubItem, 0

		;get local address, convert to string and add to listview
		mov		eax, (MIB_TCPROW ptr [edi]).dwLocalAddr
		invoke	inet_ntoa, eax
		mov		tempItem.pszText, eax

		invoke	SendMessage, hMainListView, LVM_INSERTITEM,\
					0, addr tempItem
		
		;get local port, convert to string and add to listview
		mov		eax, (MIB_TCPROW ptr [edi]).dwLocalPort
		
		mov		edx, eax 
		shr		edx, 8	 
		shl		ax, 8    
		or		eax, edx
		lea		ecx, tempBuffer
		invoke	dwtoa, eax, ecx
		lea		eax, tempBuffer
		mov		tempItem.pszText, eax
		inc		tempItem.iSubItem

		;get remote address, convert to string and add to listview
		invoke	SendMessage, hMainListView, LVM_SETITEM,\
					0, addr tempItem
	
		mov		eax, (MIB_TCPROW ptr [edi]).dwRemoteAddr
		invoke	inet_ntoa, eax
		mov		tempItem.pszText, eax
		inc		tempItem.iSubItem
		
		invoke	SendMessage, hMainListView, LVM_SETITEM,\
					0, addr tempItem
		
		;get remote port, convert to string and add to listview
		mov		eax, (MIB_TCPROW ptr [edi]).dwRemotePort
		mov		edx, eax 
		shr		edx, 8	 
		shl		ax, 8    
		or		eax, edx
		lea		ecx, tempBuffer
		invoke	dwtoa, eax, ecx
		lea		eax, tempBuffer
		mov		tempItem.pszText, eax
		inc		tempItem.iSubItem

		invoke	SendMessage, hMainListView, LVM_SETITEM,\
					0, addr tempItem
					
		; Get state, look up string for it in stateTable and add to listview
		mov		eax, (MIB_TCPROW ptr [edi]).dwState
		
		.IF		eax>12
			mov		eax, 13
		.ENDIF
		dec		eax
		mov		eax, stateTable[eax*4]
			
		mov		tempItem.pszText, eax
		inc		tempItem.iSubItem
		
		invoke	SendMessage, hMainListView, LVM_SETITEM,\
					0, addr tempItem
		

		add	edi, SIZEOF MIB_TCPROW
		inc	esi
	.ENDW
	
	pop		edi
	
	; --- free mem ---
	invoke	GlobalFree, edi
	
	; --- Unlock window ---
	invoke	LockWindowUpdate, 0
ret
UpdateListView endp

; #########################################################################

KillConnection proc	uses ebx
LOCAL tempItem:LV_ITEM
LOCAL tempBuffer[128]:BYTE
LOCAL tempRow:MIB_TCPROW

	; Set state to DELETE_TCB, to kill the connection
	mov		tempRow.dwState, MIB_TCP_STATE_DELETE_TCB
	
	; Get the selected item
	invoke	SendMessage, hMainListView, LVM_GETNEXTITEM, -1, LVNI_SELECTED	
	.IF		eax==-1
		; beep if nothing is selected
		invoke	MessageBeep, 0
		ret
	.ENDIF
	mov		ebx, eax
	
	; Initialize tempItem to retrieve info about selected item
	lea		ecx, tempBuffer
	mov		tempItem.imask, LVIF_TEXT
	mov		tempItem.iItem, ebx
	and		tempItem.iSubItem, 0
	mov		tempItem.pszText, ecx
	mov		tempItem.cchTextMax, 128
	
	; Get item info
	invoke	SendMessage, hMainListView, LVM_GETITEM, 0, addr tempItem
	
	;-----------------
	; Convert all item data to values for tempRow:
	invoke	inet_addr, addr tempBuffer
	mov		tempRow.dwLocalAddr, eax
	
	inc		tempItem.iSubItem
	invoke	SendMessage, hMainListView, LVM_GETITEM, 0, addr tempItem
	
	invoke	atodw, addr tempBuffer
	mov		edx, eax
	shl		dx, 8
	shr		eax,8
	or		eax, edx
	mov		tempRow.dwLocalPort, eax
	
	inc		tempItem.iSubItem
	invoke	SendMessage, hMainListView, LVM_GETITEM, 0, addr tempItem
	
	invoke	inet_addr, addr tempBuffer
	mov		tempRow.dwRemoteAddr, eax
	
	inc		tempItem.iSubItem
	invoke	SendMessage, hMainListView, LVM_GETITEM, 0, addr tempItem
	
	invoke	atodw, addr tempBuffer
	mov		edx, eax
	shl		dx, 8
	shr		eax,8
	or		eax, edx
	mov		tempRow.dwRemotePort, eax
	
	; Pass tempRow to SetTcpEntry to kill the connection:
	invoke	SetTcpEntry, addr tempRow
	.IF		eax!=NO_ERROR
		;failed
		invoke	MessageBeep, MB_ICONERROR
	.ELSE
		;succeeded, delete item from list:
		invoke	SendMessage, hMainListView, LVM_DELETEITEM, ebx, 0
	.ENDIF

ret
KillConnection endp
end start




